import java.util.Arrays;

public class ArrayList <T> implements Cloneable {


    private T[] data;
    private int count;
    private static final int default_capacity = 10;

    public ArrayList(){
        this.data = (T[])new Object [default_capacity];
        this.count =0;

    }

    public int size (){

        return count;

    }

    @SuppressWarnings("unchecked")
    public T get (int i){

        if(i >= count || i <0){

            throw new IndexOutOfBoundsException("Index: " + i + ", Size " + i);

        }
            return (T) data[i];
    }

    @SuppressWarnings("unchecked")
    public T set (int i , T t){

        if(i>= count || i <0){

            throw new IndexOutOfBoundsException("Index: " + i + ", Size" + i);

        }

        T oldobj = (T)data[i];
        data[i] = t;
        return oldobj;
    }

    public Boolean adding(T t){
//
//        if (t == null){
//            return false;
//        } kinda broke oops
        data[count] = t;
        count++;
        ensureCap();
        return true;

    }

    public Boolean addingIndex(int index,T t ){

        T[] newArray = Arrays.copyOfRange(data,0,index);
        T[] newArray2 = Arrays.copyOfRange(data,index,data.length);

        data = newArray;
        add(t);
        data = merge(newArray,newArray2);
        return true;

    }


    public T [] merge (T[] arr1, T[] arr2){

        T[] arrmerge =  (T []) new Object[arr1.length + arr2.length];
        int counter = 0;

        for (T t: arr1) {
                arrmerge[counter] = t;
                counter ++;
        }
        for (T t : arr2) {
            arrmerge[counter] = t;
            counter++;
        }
        return arrmerge;

    }

    public void add (T t){

        if(count == data.length){

            ensureCap();

        }
        data[count++] = t;


    }
    public T remove(int i) {


        if(i < 0 || i >= count) {

            throw new IndexOutOfBoundsException();
        }
        T oldT = (T)data[i];
            for(int j = i; j < count-1; j++){

                data[j] = data[j+1];

            }
        count --;
        data[count] = null;
        return oldT;
        }




    public void clear (){

        for (int j = 1; j < data.length ; j++) {
            data[j] = null;
            count--;

        }

    }




    public Boolean isEmpty(){

        return count==0;

    }
    public Integer getIndexOf(T t){
        for (int i = 0; i <count; i++) {


            if(data[i].equals(t))
                return i;

        }
        return -1;
    }



    public Boolean contains(T t){

        for (int i = 0; i < size(); i++) {
            if(data[i].equals(t)){

                return true;

            }
        }
        return false;
    }

    public ArrayList<T> clone (ArrayList<T> arrayList) throws CloneNotSupportedException{
            ArrayList<T>clone = (ArrayList<T>)super.clone();
            return clone;

    }


    public void ensureCap(){

        if(count < data.length) return;

            int newSize = data.length * 2;
            data = Arrays.copyOf(data, newSize);

    }



}
